﻿using Health.Infra;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using Newtonsoft.Json;

namespace Health.Api.Infrastructure
{
    public class JsonHelper : IJsonConverter
    {
        private readonly JsonSerializerSettings _serializerSettings;

        public JsonHelper(IOptions<MvcNewtonsoftJsonOptions> options)
        {
            _serializerSettings = options.Value.SerializerSettings;
        }
        public T Deserialize<T>(string json)
        {
            return JsonConvert.DeserializeObject<T>(json, _serializerSettings);
        }

        public string Serialize(object @object)
        {
            return JsonConvert.SerializeObject(@object, Formatting.None, _serializerSettings);
        }
    }
}
