﻿using System.Collections.Generic;

namespace Health.Api.Infrastructure
{
    public class Page
    {
        public Page() : this(1, 30) { }
        public Page(int index) : this(index, 30) { }

        public Page(int index, int size)
        {
            Index = index;
            Size = size;
        }

        /// <summary>
        /// 页码
        /// </summary>
        public int Index { get; set; }
        /// <summary>
        /// 页行数 默认30
        /// </summary>
        public int Size { get; set; }
    }

    public class Page<TEntity> : Page
    {
        public Page(int total, IEnumerable<TEntity> data)
        {
            Total = total;
            Data = data;
        }

        public Page(int index, int size, int total, IEnumerable<TEntity> data)
            : base(index, size)
        {
            Total = total;
            Data = data;
        }

        public int Total { get; set; }
        public IEnumerable<TEntity> Data { get; set; }
    }
}
