﻿using Dapper;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
//using Health.Api.Infrastructure.Models;
using Health.Api.Infrastructure.Modules;
using Health.Api.Infrastructure.Request;
using Health.Infra;
using StackExchange.Profiling;
using StackExchange.Profiling.Data;
using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Linq;
using System.Threading.Tasks;
using static UtilExtensions;

namespace Health.Api.Infrastructure.Queries
{
    public class ResourceQueries
    {
        private readonly string _Connection156;
        private readonly string _configConnectionString;
        private readonly string _Connection151;
        private readonly string _Connection152;
        private readonly string _Connection153;
        private readonly string _Connection154;
        private readonly string _Connection155;
        private readonly string _Connection158;
        //private List<Common> a;
        bool state = true;
        public ResourceQueries(string Connection156, string configConnectionString, string Connection151, string Connection152, string Connection153, string Connection154, string Connection155, string Connection158)
        {
            _Connection156 = Connection156;
            _configConnectionString = configConnectionString;
            _Connection151 = Connection151;
            _Connection152 = Connection152;
            _Connection153 = Connection153;
            _Connection154 = Connection154;
            _Connection155 = Connection155;
            _Connection158 = Connection158;
        }
        /// <summary>
        /// 查询所有项目
        /// </summary>
        public IEnumerable<dynamic> ItemQuery()
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                var query = @" SELECT ID, PROJECT_NAME, GENERIC_NAME, DISEASE_NAME, ICD,
                    COMPLETE_MARK, search_time
                     FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_SEARCH_RECORD]
                      WHERE year(search_time)=year(GETDATE()) AND MONTH(search_time)=MONTH(GETDATE()) order by id DESC ";
                return connection.Query(query).ToList();
            }
        }
        /// <summary>
        /// 停止正在查询项目
        /// </summary>
        public bool CancelProject(int id)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                //确定该项目在执行中
                IEnumerable<dynamic> COMPLETE_MARK = connection.Query("select COMPLETE_MARK FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_SEARCH_RECORD] where COMPLETE_MARK =22 and id=" + id);
                var result = false;//默认状态不成功
                if (COMPLETE_MARK.Count() > 0)
                    throw new DomainException("该项目已经执行完毕,不能取消！！！");
                else
                    result = connection.Execute("update [SV_MEDIC_STATISTICS].[dbo].[MEDIC_SEARCH_RECORD] set COMPLETE_MARK = 22 where and COMPLETE_MARK != 22 id= " + id) > 0 ? true : false;
                if (result)
                    return connection.Execute("delete [SV_MEDIC_STATISTICS].[dbo].[MEDIC_SEARCH_RECORD] where COMPLETE_MARK = 22 and id= " + id) > 0 ? true : false;
                else
                    throw new DomainException("该项目强行停止，但是删除记录失败，请执行delete [SV_MEDIC_STATISTICS].[dbo].[MEDIC_SEARCH_RECORD] where COMPLETE_MARK = 22 and id= " + id);
            }
            return false;
        }
        public (IEnumerable<dynamic>, IEnumerable<dynamic>) ShowMEDIC_AREA(int id, int paseIndex)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                IEnumerable<dynamic> sj = connection.Query($@"select*FROM(
                 SELECT  ROW_NUMBER() OVER(ORDER BY getdate())AS id,* FROM(
                 SELECT DISTINCT 
                       [MEDIC_AREA]
                   FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_AREA] WHERE INDEXS={id} AND MEDIC_AREA IS NOT  NULL AND MEDIC_AREA<>''  
                       )a
                 	  )b
                 	   WHERE id<={paseIndex}*10 and id>({paseIndex}-1)*10
                 ").ToList();
                IEnumerable<dynamic> zon = connection.Query($@"   SELECT  CAST(COUNT(*)AS MONEY)totalCount ,{paseIndex} paseIndex FROM(
                 SELECT DISTINCT 
                       [MEDIC_AREA]
                   FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_AREA] WHERE INDEXS={id} AND MEDIC_AREA IS NOT  NULL AND MEDIC_AREA<>''  
                       )a").ToList();
                return (sj, zon);
            }
            return (null, null);
        }
        public (IEnumerable<dynamic>, IEnumerable<dynamic>) ShowITEM_NAME(int id, int paseIndex)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                IEnumerable<dynamic> sj = connection.Query($@"select*FROM(
                 SELECT  ROW_NUMBER() OVER(ORDER BY getdate())AS id,* FROM(
                 SELECT DISTINCT 
                       [ITEM_NAME]
                   FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_AREA] WHERE INDEXS={id} AND ITEM_NAME IS NOT  NULL AND ITEM_NAME<>''  
                       )a
                 	  )b
                 	   WHERE id<={paseIndex}*10 and id>({paseIndex}-1)*10
                 ").ToList();
                IEnumerable<dynamic> zon = connection.Query($@"   SELECT  CAST(COUNT(*)AS MONEY)totalCount ,{paseIndex} paseIndex FROM(
                 SELECT DISTINCT 
                       [ITEM_NAME]
                   FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_AREA] WHERE INDEXS={id} AND ITEM_NAME IS NOT  NULL AND ITEM_NAME<>''  
                       )a").ToList();
                return (sj, zon);
            }
            return (null, null);
        }
        /// <summary>
        ///报告展示（疾病展示所有，药品可以填写）
        /// </summary>
        public (IEnumerable<dynamic>, IEnumerable<dynamic>, string, string) ProjectReport(int id, string MEDIC_AREA, string item_name, string GENERIC_NAME, string PROJECT_NAME, string icd, string DISEASE_NAME)
        {
            bool result = deleteShow();
            if (result)
                result = addShow(id, MEDIC_AREA == "" ? null : MEDIC_AREA, item_name == "" ? null : item_name);
            else
                throw new DomainException("请重试！！！");
            if (result)
                return Show(id, MEDIC_AREA == "" ? null : MEDIC_AREA, GENERIC_NAME == "" ? null : GENERIC_NAME, PROJECT_NAME == "" ? null : PROJECT_NAME, icd == "" ? null : icd, DISEASE_NAME == "" ? null : DISEASE_NAME);
            return (null, null, null, null);
        }
        /// <summary>
        /// 删除MEDIC_PERSON_INFORMATION_存储过程表的记录
        /// </summary>
        public bool deleteShow()
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                bool a = connection.Execute("delete [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表]") >= 0 ? true : false;
                return a;
            }
            return false;
        }
        /// <summary>
        /// 添加本次查询的记录到 MEDIC_PERSON_INFORMATION_存储过程表
        /// </summary>
        public bool addShow(int id, string MEDIC_AREA, string ITEM_NAME)
        {
            if (MEDIC_AREA is null)
                MEDIC_AREA = "1=1";
            else
            {
                MEDIC_AREA = MEDIC_AREA.Replace("，", ",");
                MEDIC_AREA = "MEDIC_AREA LIKE '%" + MEDIC_AREA.Replace(",", " %' or MEDIC_AREA like '%") + "%'";
            }
            if (ITEM_NAME is null)
                ITEM_NAME = "and (1=1)";
            else
            {
                ITEM_NAME = ITEM_NAME.Replace("，", ",");
                ITEM_NAME = " ITEM_NAME LIKE '%" + ITEM_NAME.Replace(",", " %' or ITEM_NAME like '%") + "%'";
                ITEM_NAME = "and (" + ITEM_NAME + ")";
            }
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                var AddQuery = $@" 
                         insert into [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表]
                     (ID, HOS_ID, MASTER_INDEX, BIRTHDAY, SEX, PERSON_CODE, PERSON_ID, REG_CODE, REG_ID, REG_SOURCE, REG_TIME, AREA_ID, INDEXS, TYPE, DEPT_NAME, MEDIC_AREA)
                        SELECT a.* ,b.[MEDIC_AREA] FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION] a
                      left join [SV_MEDIC_STATISTICS].[dbo].[MEDIC_AREA] b on a.AREA_ID = b.ID AND a.INDEXS=b.INDEXS AND a.TYPE=b.TYPE
                        where({MEDIC_AREA})  {ITEM_NAME} and a.TYPE = 1 AND a.INDEXS IN(" + id + ")";

                return connection.Execute(AddQuery) >= 0 ? true : false;
            }
            return false;
        }
        /// <summary>
        /// 展示结果
        /// </summary>
        public (IEnumerable<dynamic>, IEnumerable<dynamic>, string, string) Show(int id, string MEDIC_AREA, string GENERIC_NAME, string PROJECT_NAME, string icd, string DISEASE_NAME)
        {
            using (DbConnection connection = new SqlConnection(_Connection156))
            {
                var ShowQuery1 = "";
                var ShowQuery2 = "";
                ShowQuery1 = @"SELECT * FROM (
	  SELECT '总'n,COUNT(*)RS FROM (
	  SELECT  DISTINCT   HOS_ID,MASTER_INDEX 
	  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN (" + id + @")) S
	  union all 
	SELECT cast(N as nvarchar(10))n,COUNT(*)RS FROM (
	SELECT  DISTINCT  YEAR([REG_TIME])N, HOS_ID,MASTER_INDEX 
	  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN (" + id + @")   AND YEAR(REG_TIME)>=2014
	  ) S GROUP BY N 
	 UNION ALL 
	 SELECT '2013'N,COUNT(*)RS FROM (
	  SELECT  DISTINCT   HOS_ID,MASTER_INDEX 
	  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN(" + id + @")
	   AND YEAR(REG_TIME)<=2013 ) S 
	   )S PIVOT (SUM(RS)  FOR N IN ([2013],[2014],[2015],[2016],[2017],[2018],[2019],[2020],[总]))V";

                ShowQuery2 = @"SELECT '医院区域'classification, PROVINCE hospital,COUNT(DISTINCT case when CODE is not null then code else HOS_ID end)hospitalsSUM,COUNT(*)patientSUM FROM (
						 SELECT DISTINCT HOS_ID,MASTER_INDEX,replace([Province],' ','')PROVINCE,CODE
						 FROM (SELECT  DISTINCT   HOS_ID,MASTER_INDEX
  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN (" + id + @" )) A
						  JOIN [DB_SV_DATA_CONFIG].[DBO].[SYS_HOSPITAL] B ON A.HOS_ID=B.ID    
						  ) N  GROUP BY PROVINCE
						  UNION ALL 
						SELECT '医院级别'JB,HOSLEVEL,COUNT(DISTINCT case when CODE is not null then code else HOS_ID end ),COUNT(*)RS FROM (
						 SELECT DISTINCT HOS_ID,MASTER_INDEX,PROVINCE,CODE,
						 CASE WHEN HOSLEVEL LIKE '%三%' THEN '三级' WHEN HOSLEVEL  LIKE '%二%' THEN '二级'
						 ELSE '一级' END HOSLEVEL, 
						 HOSTYPE FROM (SELECT  DISTINCT   HOS_ID,MASTER_INDEX
  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN (" + id + @" )) A
						  JOIN [DB_SV_DATA_CONFIG].[DBO].[SYS_HOSPITAL] B ON A.HOS_ID=B.ID    
						  ) N  GROUP BY HOSLEVEL
							UNION ALL 
						SELECT '医院类别'LB,HOSTYPE,COUNT(DISTINCT case when CODE is not null then code else HOS_ID end),COUNT(*)RS FROM (
						 SELECT DISTINCT HOS_ID,MASTER_INDEX,CODE,
						 HOSTYPE FROM (SELECT  DISTINCT   HOS_ID,MASTER_INDEX
  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN(" + id + @") ) A
						  JOIN [DB_SV_DATA_CONFIG].[DBO].[SYS_HOSPITAL] B ON A.HOS_ID=B.ID    
						  ) N  GROUP BY HOSTYPE
						   UNION ALL
						  SELECT '总览'ZL,'医院数',COUNT(DISTINCT case when CODE is not null then code else HOS_ID end),COUNT(*)RS FROM (
						  SELECT DISTINCT HOS_ID,MASTER_INDEX,CODE,
						 HOSTYPE FROM (SELECT  DISTINCT   HOS_ID,MASTER_INDEX
  FROM [SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION_存储过程表] WHERE TYPE=1 AND INDEXS IN(" + id + @") ) A
						  JOIN [DB_SV_DATA_CONFIG].[DBO].[SYS_HOSPITAL] B ON A.HOS_ID=B.ID   
						  ) N ";
                IEnumerable<dynamic> yearfb = connection.Query(ShowQuery1);
                IEnumerable<dynamic> dqfb = connection.Query(ShowQuery2).ToList();
                var condition = "";
                if (icd != "" && icd != null) condition = "ICD:" + icd;
                if (DISEASE_NAME != "" && DISEASE_NAME != null) condition = condition + @"疾病名称：" + DISEASE_NAME;
                if (GENERIC_NAME != "" && GENERIC_NAME != null) condition = condition + @"药品名称：" + GENERIC_NAME;
                if (MEDIC_AREA != "" && MEDIC_AREA != null) condition = condition + @"产地：" + MEDIC_AREA;

                return (yearfb, dqfb, condition, PROJECT_NAME);
            }
            return (null, null, null, null);
        }
        /// <summary>
        /// 创建流水表
        /// </summary>
        public bool EstablishFlowDatabaseTable(string PROJECT_NAME, string sql, int id, string remarks)
        {
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                int isfilter = 1;
                if (connection.Query("select *from [SV_QueryPlatform].[dbo].[FlowReservoirStatus] where tableName like '%" + PROJECT_NAME + "%'").Count() > 0)
                {
                    throw new DomainException(PROJECT_NAME + "流水库表已存在！");
                }
                else
                {
                    if (sql == "" || sql == null)
                    {
                        isfilter = 0;
                        sql = $"SELECT distinct MASTER_INDEX,hos_id FROM[192.168.18.156].[SV_MEDIC_STATISTICS].[dbo].[MEDIC_PERSON_INFORMATION] WHERE indexs = {id} and TYPE = 1";
                    }


                    if (connection.Execute($@"INSERT INTO[SV_QueryPlatform].[dbo].[FlowReservoirStatus]([tableName] ,[createDate] ,[state],indexs,isfilter,[sql],remarks) 
                        select'{PROJECT_NAME}', getdate(), 0,{id} ,{isfilter},'INSERT INTO[SV_QueryPlatform].[dbo].[{PROJECT_NAME}]([MASTER_INDEX],[HOS_ID]){sql }','{remarks}'") > 0 ? true : false)
                    {
                        connection.Execute(@"CREATE TABLE [SV_QueryPlatform].[dbo].[" + PROJECT_NAME + "]([MASTER_INDEX][INT] NULL,[HOS_ID][INT] NULL) ON[PRIMARY]");
                        if (connection.Query(@"select * from[SV_QueryPlatform].sys.tables WHERE name = '" + PROJECT_NAME + "'").Count() > 0 ? true : false)
                        {
                            return connection.Execute("INSERT INTO [SV_QueryPlatform].[dbo].[" + PROJECT_NAME + "]([MASTER_INDEX],[HOS_ID])" + sql) > 0 ? true : false;
                        }
                        else
                        {
                            throw new DomainException("创建 [SV_QueryPlatform].[dbo].[" + PROJECT_NAME + "]流水库表成功，插入人群时报错！插入数据先病人再医院编码");
                        }
                    }
                    else
                    {
                        throw new DomainException("创建 [SV_QueryPlatform].[dbo].[" + PROJECT_NAME + "]流水库表失败");
                    }
                }
            }
            return false;
        }
        /// <summary>
        /// 查询日志
        /// </summary>
        public (IEnumerable<dynamic>, IEnumerable<dynamic>) ShowLog(int indexs, int paseIndex, string type)
        {
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                type = string.IsNullOrEmpty(type) ? "" : $"AND LEFT(type,2)='{type}'";
                return (connection.Query($@" select*FROM(
                    SELECT  ROW_NUMBER() OVER(ORDER BY getdate())AS id,* FROM(
                   SELECT   INDEXS, hos_code, LOG, CreateDate, type, case when  type not like '%成功%' then 错误sql  else '' end [错误sql]
                   FROM [SV_QueryPlatform].[dbo].[SYS_LOG] WHERE indexs ={indexs} {type}
                   )a )b  WHERE id<={paseIndex}*20 and id>({paseIndex}-1)*20").ToList(),
               connection.Query($@"SELECT   COUNT(*),CAST(COUNT(*)AS MONEY)totalCount ,{paseIndex} paseIndex
                     FROM [SV_QueryPlatform].[dbo].[SYS_LOG] WHERE indexs ={indexs} {type}
                      SELECT  *FROM [SV_QueryPlatform].[dbo].[SYS_LOG] WHERE indexs =5226 ORDER BY CreateDate DESC").ToList());
            }
        }
        /// <summary>
        /// 查询流水表
        /// </summary>
        public IEnumerable<dynamic> QueryFlowDatabase()
        {
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                CheckTimeout();
                return connection.Query(@"SELECT * FROM[SV_QueryPlatform].[dbo].[FlowReservoirStatus]").ToList();
            }
        }
        /// <summary>
        /// 日志
        /// </summary>
        public bool LOG(string LOG, string hos_code, int indexs, string? type, string? sql)
        {
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                sql = sql.Replace("'", "''");
                return connection.Execute($@"INSERT INTO[SV_QueryPlatform].[dbo].[SYS_LOG]([INDEXS] ,hos_code,[createDate] ,[LOG],type,[错误sql]) 
                          select'{indexs}','{hos_code}', getdate(),'{LOG} ','{type}','{sql}'") > 0 ? true : false;
            }
        }
        /// <summary>
        /// sql查询
        /// </summary>
        public string[] ShowSql(string TableName)
        {
            var sql = "";
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                sql = $@"   SELECT sql FROM  [SV_QueryPlatform].[dbo].[Execute_SQL] WHERE type=1 AND TableName ='{TableName}' ";
                string[] A = connection.Query<string>(sql).ToArray();
                return A;
            }
        }
        /// <summary>
        /// 创建流水库
        /// </summary>
        public bool CreateAFlow_Library(string DatabaseName, int indexs)
        {
            //建立流水库脚本 
            using (DbConnection connection = new SqlConnection(_configConnectionString))
            {
                var sql = $@"CREATE DATABASE [DB_{DatabaseName}] CONTAINMENT = NONE ON  PRIMARY ( NAME = N'DB_{DatabaseName}', FILENAME = N'e:\database\DB_{DatabaseName}.mdf' , SIZE = 1454080KB , MAXSIZE = UNLIMITED, FILEGROWTH = 1024KB ) LOG ON ( NAME = N'DB_{DatabaseName}_log', FILENAME = N'e:\database\DB_{DatabaseName}_log.ldf' , SIZE = 388544KB , MAXSIZE = 2048GB , FILEGROWTH = 10%)ALTER DATABASE [DB_{DatabaseName}] SET COMPATIBILITY_LEVEL = 120
                                      IF (1 = FULLTEXTSERVICEPROPERTY('IsFullTextInstalled'))
                                      EXEC [DB_{DatabaseName}].[dbo].[sp_fulltext_database] @action = 'enable'
                                      ALTER DATABASE [DB_{DatabaseName}] SET ANSI_NULL_DEFAULT OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET ANSI_NULLS OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET ANSI_PADDING OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET ANSI_WARNINGS OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET ARITHABORT OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET AUTO_CLOSE OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET AUTO_SHRINK OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET AUTO_UPDATE_STATISTICS ON 
                                      ALTER DATABASE [DB_{DatabaseName}] SET CURSOR_CLOSE_ON_COMMIT OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET CURSOR_DEFAULT  GLOBAL
                                      ALTER DATABASE [DB_{DatabaseName}] SET CONCAT_NULL_YIELDS_NULL OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET NUMERIC_ROUNDABORT OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET QUOTED_IDENTIFIER OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET RECURSIVE_TRIGGERS OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET  DISABLE_BROKER 
                                      ALTER DATABASE [DB_{DatabaseName}] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET DATE_CORRELATION_OPTIMIZATION OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET TRUSTWORTHY OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET ALLOW_SNAPSHOT_ISOLATION OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET PARAMETERIZATION SIMPLE 
                                      ALTER DATABASE [DB_{DatabaseName}] SET READ_COMMITTED_SNAPSHOT OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET HONOR_BROKER_PRIORITY OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET RECOVERY FULL
                                      ALTER DATABASE [DB_{DatabaseName}] SET  MULTI_USER 
                                      ALTER DATABASE [DB_{DatabaseName}] SET PAGE_VERIFY CHECKSUM  
                                      ALTER DATABASE [DB_{DatabaseName}] SET DB_CHAINING OFF 
                                      ALTER DATABASE [DB_{DatabaseName}] SET FILESTREAM( NON_TRANSACTED_ACCESS = OFF ) 
                                      ALTER DATABASE [DB_{DatabaseName}] SET TARGET_RECOVERY_TIME = 0 SECONDS 
                                      ALTER DATABASE [DB_{DatabaseName}] SET DELAYED_DURABILITY = DISABLED 
                                      ALTER DATABASE [DB_{DatabaseName}] SET  READ_WRITE  ";
                connection.Execute(sql);
                if (connection.Query("select name from dbo.sysdatabases where name='DB_" + DatabaseName + "'").Count() > 0 ? true : false)
                {
                    try
                    {
                        LOG($@"创建DB_{DatabaseName} 流水库成功！", "", indexs, "", "");
                        sql = $@"     CREATE TABLE [DB_{DatabaseName}].[dbo].[ASSAY_REPORT](
                                 	[REPORT_ID] [bigint]  IDENTITY(1,1) NOT NULL,
                                 	[REPORT_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[REPORT_TIME] [datetime] NULL,
                                 	[SPECIMEN_TYPE] [nvarchar](max) NULL,
                                 	[ASSAY_ITEM_CODE] [nvarchar](max) NULL,
                                 	[ASSAY_ITEM_NAME] [nvarchar](max) NULL,
                                 	[ITEM_ENAME] [nvarchar](max) NULL,
                                 	[UNIT] [nvarchar](max) NULL,
                                 	[RESULTS] [nvarchar](max) NULL,
                                 	[REFRANGE] [nvarchar](max) NULL,
                                 	[RESULTSTATUS] [nvarchar](max) NULL,
                                 	[REG_SOURCE] [int] NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                  CONSTRAINT [PK_ASSAY_REPORT] PRIMARY KEY CLUSTERED 
                                 (
                                 	[REPORT_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[EXEC_REPORT](
                                 	[REPORT_ID] [bigint]IDENTITY(1,1)  NOT NULL,
                                 	[REPORT_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[ORDER_ID] [bigint] NULL,
                                 	[ORDER_CODE] [nvarchar](max) NULL,
                                 	[PATIENT_MEDICALREC] [nvarchar](max) NULL,
                                 	[EXAMINE_NAME] [nvarchar](max) NULL,
                                 	[EXAMINE_SHOW] [nvarchar](max) NULL,
                                 	[EXAMINE_RESULT] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[REPORT_TIME] [datetime] NULL,
                                 	[REG_SOURCE] [int] NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                  CONSTRAINT [PK_EXEC_REPORT] PRIMARY KEY CLUSTERED 
                                 (
                                 	[REPORT_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[INPAT_DIAG](
                                 	[DIAG_ID] [bigint]IDENTITY(1,1)  NOT NULL,
                                 	[DIAG_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ICD] [nvarchar](max) NULL,
                                 	[DISEASE_NAME] [nvarchar](max) NULL,
                                 	[REMARKS] [nvarchar](max) NULL,
                                 	[TYPE] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[DIAG_TIME] [datetime] NULL,
                                 	[CURE_STATUS] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                  CONSTRAINT [PK_INPAT_DIAG] PRIMARY KEY CLUSTERED 
                                 (
                                 	[DIAG_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[INPAT_FEE](
                                 	[CHARGE_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[CHARGE_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[CATERY] [nvarchar](max) NULL,
                                 	[ITEM_TYPE] [nvarchar](max) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ITEM_NAME] [nvarchar](max) NULL,
                                 	[UNITPRICE] [money] NULL,
                                    [QUANTITY] [money] NULL,
                                 	[CATEGORY] [nvarchar](max) NULL,
                                 	[UNIT] [nvarchar](max) NULL,
                                 	[FEE] [money] NULL,
                                 	[CHARGE_TIME] [datetime] NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[DEPT_CODE] [nvarchar](max) NULL,
                                 	[DEPT_NAME] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[I_TYPE_NAME] [nvarchar](max) NULL,
                                 	[MEDIC_AREA] [nvarchar](max) NULL,
                                 	 EXEC_DEPT_CODE NVARCHAR(max)null,
                                 	 EXEC_DEPT_NAME NVARCHAR(max)null,
                                 	 EXEC_EMP_CODE NVARCHAR(max)null,
                                 	 EXEC_EMP_NAME varbinary(max) NULL
                                  CONSTRAINT [PK_INPAT_FEE] PRIMARY KEY CLUSTERED 
                                 (
                                 	[CHARGE_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[INPAT_ORDER](
                                 	[ORDER_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[ORDER_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[MEDICAL_ORDER_TYPE] [nvarchar](max) NULL,
                                 	[ITEM_TYPE] [nvarchar](max) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ITEM_NAME] [nvarchar](max) NULL,
                                 	[SKINTEST] [nvarchar](max) NULL,
                                 	[MEDI_SPEC] [nvarchar](max) NULL,
                                 	[EACH_DOSE] [nvarchar](max) NULL,
                                 	[MEDI_DOSE_UNIT] [nvarchar](max) NULL,
                                 	[MEDIC_USE_QUANTITY] [nvarchar](max) NULL,
                                 	[MEDI_USE_UNIT] [nvarchar](max) NULL,
                                 	[MEDIC_USE_PLAN] [nvarchar](max) NULL,
                                 	[MEDIC_USE_MODE] [nvarchar](max) NULL,
                                 	[MEDIC_QUANTITY] [nvarchar](max) NULL,
                                 	[UNITPRICE] [money] NULL,
                                 	[MEDICAL_ORDER_DAYS] [nvarchar](max) NULL,
                                 	[INTAKE_START_TIME] [datetime] NULL,
                                 	[INTAKE_END_TIME] [datetime] NULL,
                                 	[INTAKE_DATES] [int] NULL,
                                 	[REMARKS] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[MEDIC_AREA] [nvarchar](max) NULL,
                                  CONSTRAINT [PK_INPAT_ORDER] PRIMARY KEY CLUSTERED 
                                 (
                                 	[ORDER_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[INPAT_REG_INFO](
                                 	[REG_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[PERSON_ID] [bigint] NULL,
                                 	[PERSON_CODE] [nvarchar](100) NULL,
                                 	[IN_DEPT_CODE] [nvarchar](max) NULL,
                                 	[IN_DEPT_NAME] [nvarchar](max) NULL,
                                 	[WARD_NAME] [nvarchar](max) NULL,
                                 	[EMP_CODE_INCHARGE] [nvarchar](max) NULL,
                                 	[EMP_NAME_INCHARGE] [varbinary](max) NULL,
                                 	[EMP_CODE_RESIDENT] [nvarchar](max) NULL,
                                 	[EMP_NAME_RESIDENT] [varbinary](max) NULL,
                                 	[INHOS_TIME] [datetime] NULL,
                                 	[OUTHOS_TIME] [datetime] NULL,
                                 	[CARD_TYPE] [nvarchar](max) NULL,
                                 	[CARD_ID] [nvarchar](max) NULL,
                                 	[HEIGHT] [nvarchar](max) NULL,
                                 	[WEIGHT] [nvarchar](max) NULL,
                                 	[INHOS_STATUS] [nvarchar](max) NULL,
                                 	[OUTHOS_STATUS] [nvarchar](max) NULL,
                                 	[F_DIAG] [nvarchar](max) NULL,
                                 	[I_DEPT_NAME] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[I_CARD_TYPE] [nvarchar](max) NULL,
                                 	[WAISTLINE] [nvarchar](max) NULL,
                                 	[TOTAL_FEE] [money] NULL,
                                 	[PAY_FEE] [money] NULL,
                                 	 OUT_DEPT_CODE NVARCHAR(max) null,
                                 	 OUT_DEPT_NAME NVARCHAR(max)null,
                                 	 SOURCE NVARCHAR(max)null
                                  CONSTRAINT [PK_INPAT_REG_INFO] PRIMARY KEY CLUSTERED 
                                 (
                                 	[REG_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[OPS_INFO](
                                 	[OPS_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[OPS_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[ORDER_ID] [bigint] NULL,
                                 	[ORDER_CODE] [nvarchar](max) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ITEM_NAME] [nvarchar](max) NULL,
                                 	[PODX] [nvarchar](max) NULL,
                                 	[RESULTS] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[OPS_LEVEL] [nvarchar](max) NULL,
                                 	[WOUND_LEVEL] [nvarchar](max) NULL,
                                 	[START_TIME] [datetime] NULL,
                                 	[END_TIME] [datetime] NULL,
                                 	[F_HELPER] [varbinary](max) NULL,
                                 	[S_HELPER] [varbinary](max) NULL,
                                 	[F_ANAESTHESIA] [varbinary](max) NULL,
                                 	[S_ANAESTHESIA] [varbinary](max) NULL,
                                 	[DEPT_CODE] [nvarchar](max) NULL,
                                 	[DEPT_NAME] [nvarchar](max) NULL,
                                 	[CURE_STATUS] [nvarchar](max) NULL,
                                 	[ANESTHESIA_METHOD] [nvarchar](max) NULL,
                                 	[ELECTIVE_SURGERY] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[ICD_9_CM] [nvarchar](max) NULL,
                                 	[I_ITEM_NAME] [nvarchar](max) NULL,
                                 	[I_ICD_9_CM] [nvarchar](max) NULL,
                                  CONSTRAINT [PK_OPS_INFO] PRIMARY KEY CLUSTERED 
                                 (
                                 	[OPS_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[OUT_DIAG](
                                 	[DIAG_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[DIAG_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ICD] [nvarchar](max) NULL,
                                 	[DISEASE_NAME] [nvarchar](max) NULL,
                                 	[DIAG_TIME] [datetime] NULL,
                                 	[REMARKS] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                  CONSTRAINT [PK_OUT_DIAG] PRIMARY KEY CLUSTERED 
                                 (
                                 	[DIAG_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[OUT_FEE](
                                 	[CHARGE_ID] [bigint]IDENTITY(1,1)  NOT NULL,
                                 	[CHARGE_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[CATERY] [nvarchar](max) NULL,
                                 	[ITEM_TYPE] [nvarchar](max) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[ITEM_NAME] [nvarchar](max) NULL,
                                 	[UNITPRICE] [money] NULL,
                                    [CATEGORY] [nvarchar](max) NULL,
                                 	[QUANTITY] [money] NULL,
                                 	[UNIT] [nvarchar](max) NULL,
                                 	[FEE] [money] NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[DEPT_CODE] [nvarchar](max) NULL,
                                 	[DEPT_NAME] [nvarchar](max) NULL,
                                 	[CHARGE_TIME] [datetime] NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[I_TYPE_NAME] [nvarchar](max) NULL,
                                 	[MEDIC_AREA] [nvarchar](max) NULL,
                                 	 EXEC_DEPT_CODE NVARCHAR(max)null,
                                 	 EXEC_DEPT_NAME NVARCHAR(max)null,
                                 	 EXEC_EMP_CODE NVARCHAR(max)null,
                                 	 EXEC_EMP_NAME varbinary(max) NULL
                                  CONSTRAINT [PK_OUT_FEE] PRIMARY KEY CLUSTERED 
                                 (
                                 	[CHARGE_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[OUT_PRES](
                                 	[PRES_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[PRES_CODE] [nvarchar](max) NULL,
                                 	[REG_ID] [bigint] NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[GROUPNO] [nvarchar](max) NULL,
                                 	[NO] [nvarchar](max) NULL,
                                 	[PRES_TIME] [datetime] NULL,
                                 	[PRES_TYPE] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[ITEM_CODE] [nvarchar](max) NULL,
                                 	[MEDIC_CLASS] [nvarchar](max) NULL,
                                 	[MEDIC_GENERAL_NAME] [nvarchar](max) NULL,
                                 	[MEDIC_NAME] [nvarchar](max) NULL,
                                 	[MEDIC_TYPE] [nvarchar](max) NULL,
                                 	[MEDIC_SPEC] [nvarchar](max) NULL,
                                 	[MEDIC_AREA] [nvarchar](max) NULL,
                                 	[MEDIC_USE_QUANTITY] [nvarchar](max) NULL,
                                 	[MEDIC_USE_UNIT] [nvarchar](max) NULL,
                                 	[MEDIC_USE_CODE] [nvarchar](max) NULL,
                                 	[MEDIC_USE_MODE] [nvarchar](max) NULL,
                                 	[MEDIC_DAYS] [nvarchar](max) NULL,
                                 	[MEDIC_QUANTITY] [nvarchar](max) NULL,
                                 	[MEDIC_UNIT] [nvarchar](max) NULL,
                                 	[SKINTEST] [nvarchar](max) NULL,
                                 	[MEDIC_REMARK] [nvarchar](max) NULL,
                                 	[MEDIC_INSUREANCE_TYPE] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                  CONSTRAINT [PK_OUT_PRES] PRIMARY KEY CLUSTERED 
                                 (
                                 	[PRES_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[OUT_REG_INFO](
                                 	[REG_ID] [bigint] IDENTITY(1,1) NOT NULL,
                                 	[REG_CODE] [nvarchar](100) NULL,
                                 	[PERSON_ID] [bigint] NULL,
                                 	[PERSON_CODE] [nvarchar](100) NULL,
                                 	[REG_TIME] [datetime] NULL,
                                 	[REG_EMP_CODE] [nvarchar](max) NULL,
                                 	[REG_EMP_NAME] [varbinary](max) NULL,
                                 	[DEPT_CODE] [nvarchar](max) NULL,
                                 	[DEPT_NAME] [nvarchar](max) NULL,
                                 	[EMP_CODE] [nvarchar](max) NULL,
                                 	[EMP_NAME] [varbinary](max) NULL,
                                 	[CARD_TYPE] [nvarchar](max) NULL,
                                 	[CARD_ID] [nvarchar](max) NULL,
                                 	[REG_TYPE] [nvarchar](max) NULL,
                                 	[F_DIAG] [nvarchar](max) NULL,
                                 	[I_DEPT_NAME] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[I_CARD_TYPE] [nvarchar](max) NULL,
                                 	[TOTAL_FEE] [money] NULL,
                                 	[PAY_FEE] [money] NULL,
                                  CONSTRAINT [PK_OUT_REG_INFO] PRIMARY KEY CLUSTERED 
                                 (
                                 	[REG_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 SET ANSI_PADDING OFF
                                 SET ANSI_NULLS ON
                                 SET QUOTED_IDENTIFIER ON
                                 SET ANSI_PADDING ON
                                 CREATE TABLE [DB_{DatabaseName}].[dbo].[PUB_PATIENT](
                                 	[PERSON_ID] [bigint]IDENTITY(1,1)  NOT NULL,
                                 	[PERSON_CODE] [nvarchar](100) NULL,
                                 	[SEX] [nvarchar](max) NULL,
                                 	[BIRTHDAY] [datetime] NULL,
                                 	[MARRIED] [nvarchar](max) NULL,
                                 	[PROVINCE] [nvarchar](max) NULL,
                                 	[CITY] [nvarchar](max) NULL,
                                 	[COUNTY] [nvarchar](max) NULL,
                                 	[OCCUPATION] [nvarchar](max) NULL,
                                 	[BLOOD] [nvarchar](max) NULL,
                                 	[ID_CARD] [varbinary](max) NULL,
                                 	[NATION] [nvarchar](max) NULL,
                                 	[NATIONALITY] [nvarchar](max) NULL,
                                 	[ORG_CODE] [int] NOT NULL,
                                 	[UPLOAD_TIME] [datetime] NULL,
                                 	[EDUCATIONAL_LEVEL] [nvarchar](max) NULL,
                                 	[MASTER_INDEX] nvarchar(MAX)NULL,
                                  CONSTRAINT [PK_PUB_PATIENT] PRIMARY KEY CLUSTERED 
                                 (
                                 	[PERSON_ID] ASC
                                 )WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
                                 ) ON [PRIMARY]
                                 
                                 SET ANSI_PADDING ON ";
                        connection.Execute(sql);
                        LOG($@"创建DB_{DatabaseName} 流水库表结构成功！", "", indexs, "", "");
                        sql = $@"     CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[ASSAY_REPORT]
                                 (
                                 	[REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[ASSAY_REPORT]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[EXEC_REPORT]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[EXEC_REPORT]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[INPAT_FEE]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[INPAT_FEE]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[INPAT_ORDER]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[INPAT_ORDER]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[INPAT_REG_INFO]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_PERSON_ID] ON[DB_{DatabaseName}].[dbo].[INPAT_REG_INFO]
                                 (
                                 
                                    [PERSON_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_PERSON_CODE] ON[DB_{DatabaseName}].[dbo].[INPAT_REG_INFO]
                                 (
                                 
                                    [PERSON_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[OPS_INFO]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[OPS_INFO]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[OUT_DIAG]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[OUT_DIAG]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[INPAT_DIAG]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[INPAT_DIAG]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[OUT_FEE]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[OUT_FEE]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[OUT_PRES]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_REG_ID] ON[DB_{DatabaseName}].[dbo].[OUT_PRES]
                                 (
                                 
                                    [REG_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 CREATE NONCLUSTERED INDEX[IX_PERSON_ID] ON[DB_{DatabaseName}].[dbo].[OUT_REG_INFO]
                                 (
                                 
                                    [PERSON_ID] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_REG_CODE] ON[DB_{DatabaseName}].[dbo].[OUT_REG_INFO]
                                 (
                                 
                                    [REG_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_PERSON_CODE] ON[DB_{DatabaseName}].[dbo].[OUT_REG_INFO]
                                 (
                                 
                                    [PERSON_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 SET ANSI_PADDING ON
                                 CREATE NONCLUSTERED INDEX[IX_PERSON_CODE] ON[DB_{DatabaseName}].[dbo].[PUB_PATIENT]
                                 (
                                 
                                    [PERSON_CODE] ASC
                                 )WITH(PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON[PRIMARY]
                                 ALTER DATABASE[DB_{DatabaseName}] SET READ_WRITE";
                        connection.Execute(sql);
                        LOG($@"创建DB_{DatabaseName} 流水库索引成功！", "", indexs, "", "");
                        return connection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =1 ,DatabaseName='DB_{DatabaseName}' WHERE  indexs={indexs}") > 0 ? true : false;
                    }
                    catch (Exception e)
                    {
                        LOG($@"创建DB_{DatabaseName} 流水库操作时出错！", "", indexs, "", "");
                        throw new DomainException($@"创建DB_{DatabaseName} 流水库操作时出错！");
                    }
                }
                return false;
            }
        }
        public void CheckTimeout()
        {
            using (DbConnection connection = new SqlConnection(_configConnectionString)) // DefaultConnection
            {
                string[] id = connection.Query<string>("select ID from [SV_QueryPlatform].[dbo].[FlowReservoirStatus] where[state] = 2 and DATEDIFF(HOUR, DataPullTime, getdate()) >3").ToArray();

                foreach (var item in id)
                {
                    connection.Execute($@" update [dbo].[FlowReservoirStatus] set state= 4 where id={item}");
                }
            }
        }
        /// <summary>
        /// 拉取病人表
        /// </summary>
        public void PullData(int indexs, string DatabaseName, string tableName, string biao)
        {
            var sql = "";
            //建立流水库脚本 
            // DefaultConnection 
            using (DbConnection configConnection = new SqlConnection(_configConnectionString)) // DefaultConnection
            using (DbConnection connection151 = new SqlConnection(_Connection151))
            using (DbConnection connection152 = new SqlConnection(_Connection152))
            using (DbConnection connection153 = new SqlConnection(_Connection153))
            using (DbConnection connection154 = new SqlConnection(_Connection154))
            using (DbConnection connection155 = new SqlConnection(_Connection155))
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            using (DbConnection connection158 = new SqlConnection(_Connection158))
            {
                // sys_hospital156找医院
                sql = @$"
              SELECT  DISTINCT
                     ExecOpenLink ,
                     ExecDatabase
              FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A
                     JOIN [192.168.18.181].[SV_QueryPlatform].[dbo].[{tableName}] B ON A.ID = B.HOS_ID
                     LEFT JOIN ( SELECT  *
                                 FROM [192.168.18.181].[SV_QueryPlatform].[dbo].[SYS_LOG]
                                 WHERE   INDEXS = {indexs}
                                         AND LOG = '{biao}'
                               ) C ON A.ID = CAST(LEFT(RIGHT(C.hos_code, 4),3) AS INT)
              WHERE  hos_code IS NULL;
                       ";
                List<SYS_Hospital> hospitals = connection156.Query<SYS_Hospital>(sql).ToList();


                Dictionary<string, object> pairs = new Dictionary<string, object>
                {

                };
                foreach (var hos in hospitals)
                {

                    pairs.Clear();
                    // 存在  // 不存在
                    pairs.TryAdd($"@{nameof(hos.ExecOpenLink)}", hos.ExecOpenLink);
                    pairs.TryAdd($"@{nameof(hos.ExecDatabase)}", hos.ExecDatabase);
                    pairs.TryAdd($"@{nameof(indexs)}", indexs);
                    pairs.TryAdd($"@{nameof(DatabaseName)}", DatabaseName);
                    pairs.TryAdd($"@{nameof(tableName)}", tableName);
                    pairs.TryAdd($"@{nameof(biao)}", biao);
                    // sql 数据源导出csv 导入csv 到connection 
                    var ITEM = "[@ExecOpenLink].[@ExecDatabase]";
                    //拉取病人表
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =2 ,DataPullTime=getdate() WHERE  indexs={indexs}");

                    try
                    {
                        sql = ShowSql($"{biao}")[0];
                        foreach (var item1 in pairs)
                        {
                            ITEM = ITEM.Replace(item1.Key, item1.Value.ToString());
                            sql = sql.Replace(item1.Key, item1.Value.ToString());
                        }
                        int num = 0;
                        if (hos.ExecOpenLink == "192.168.18.151")
                            num = connection151.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.152")
                            num = connection152.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.153")
                            num = connection153.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.154")
                            num = connection154.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.155")
                            num = connection155.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.156")
                            num = connection156.Execute(sql, commandTimeout: 60 * 60 * 5);
                        else if (hos.ExecOpenLink == "192.168.18.158")
                            num = connection158.Execute(sql, commandTimeout: 60 * 60 * 5);

                        configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET DataPullTime=getdate() WHERE  indexs={indexs}");
                        if (num >= 0) { LOG($"{biao}", ITEM, indexs, "成功,返回行数：" + num, sql); }
                    }
                    catch (Exception e)
                    {
                        LOG($"{biao}", ITEM, indexs, "错误", sql);
                        state = false;
                        PullData(indexs, DatabaseName, tableName, biao);//跳过错误执行未执行的医院
                    }
                }
            }
            using (DbConnection configConnection = new SqlConnection(_configConnectionString))
            {
                if (state == false)
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =3  WHERE  indexs={indexs}");
                else
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =5 WHERE  indexs={indexs}");//拉取完成
            }
        }
        public void PullData1(int indexs, string DatabaseName, string tableName, string biao)
        {
            var sql = "";
            var sql_count = "";
            int count = 0;
            //建立流水库脚本 
            // DefaultConnection 
            using (DbConnection configConnection = new SqlConnection(_configConnectionString)) // DefaultConnection
            using (DbConnection connection151 = new SqlConnection(_Connection151))
            using (DbConnection connection152 = new SqlConnection(_Connection152))
            using (DbConnection connection153 = new SqlConnection(_Connection153))
            using (DbConnection connection154 = new SqlConnection(_Connection154))
            using (DbConnection connection155 = new SqlConnection(_Connection155))
            using (DbConnection connection156 = new SqlConnection(_Connection156))
            using (DbConnection connection158 = new SqlConnection(_Connection158))
            {
                // sys_hospital156找医院
                sql = @$"
              SELECT  DISTINCT
                     ExecOpenLink ,
                     ExecDatabase
              FROM  [DB_SV_Data_Config].[dbo].[SYS_Hospital] A
                     JOIN [192.168.18.181].[SV_QueryPlatform].[dbo].[{tableName}] B ON A.ID = B.HOS_ID
                     LEFT JOIN ( SELECT  *
                                 FROM [192.168.18.181].[SV_QueryPlatform].[dbo].[SYS_LOG]
                                 WHERE   INDEXS = {indexs}
                                         AND LOG = '{biao}'
                               ) C ON A.ID = CAST(LEFT(RIGHT(C.hos_code, 4),3) AS INT)
              WHERE  hos_code IS NULL;";
                List<SYS_Hospital> hospitals = connection156.Query<SYS_Hospital>(sql).ToList();


                Dictionary<string, object> pairs = new Dictionary<string, object> { };
                foreach (var hos in hospitals)
                {

                    pairs.Clear();
                    // 存在  // 不存在
                    pairs.TryAdd($"@{nameof(hos.ExecOpenLink)}", hos.ExecOpenLink);
                    pairs.TryAdd($"@{nameof(hos.ExecDatabase)}", hos.ExecDatabase);
                    pairs.TryAdd($"@{nameof(indexs)}", indexs);
                    pairs.TryAdd($"@{nameof(DatabaseName)}", DatabaseName);
                    pairs.TryAdd($"@{nameof(tableName)}", tableName);
                    pairs.TryAdd($"@{nameof(biao)}", biao);
                    // sql 数据源导出csv 导入csv 到connection 
                    var ITEM = "[@ExecOpenLink].[@ExecDatabase]";
                    //拉取病人表
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =2 ,DataPullTime=getdate() WHERE  indexs={indexs}");

                    try
                    {
                        sql = ShowSql($"{biao}")[0];
                        if (biao == "INPAT_ORDER" || biao == "INPAT_FEE")
                        {
                            sql_count = ShowSql("INPAT_REG_INFO_COUNT")[0];
                        }
                        else if (biao == "OUT_PRES" || biao == "OUT_FEE")
                        {
                            sql_count = ShowSql("OUT_REG_INFO_COUNT")[0];
                        }

                        foreach (var item1 in pairs)
                        {
                            sql_count = sql_count.Replace(item1.Key, item1.Value.ToString());
                            ITEM = ITEM.Replace(item1.Key, item1.Value.ToString());
                            sql = sql.Replace(item1.Key, item1.Value.ToString());
                        }
                        count = configConnection.Query(sql_count, commandTimeout: 60 * 60 * 5).Count();
                        int num = 0;
                        int paseIndex = 1;
                        for (int i = count % 2000 > 0 ? (count / 2000) + 1 : count / 2000; i > 0; i--)
                        {
                            sql = ShowSql($"{biao}")[0];
                            foreach (var item1 in pairs)
                            {
                                sql = sql.Replace(item1.Key, item1.Value.ToString());
                            }
                            sql = sql.Replace("@paseIndex", paseIndex.ToString());
                            if (hos.ExecOpenLink == "192.168.18.151")
                                num = num+ connection151.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.152")
                                num = num + connection152.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.153")
                                num = num + connection153.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.154")
                                num = num + connection154.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.155")
                                num = num + connection155.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.156")
                                num = num + connection156.Execute(sql, commandTimeout: 60 * 60 * 5);
                            else if (hos.ExecOpenLink == "192.168.18.158")
                                num = num + connection158.Execute(sql, commandTimeout: 60 * 60 * 5);
                            configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET DataPullTime=getdate() WHERE  indexs={indexs}");
                         //   if (num >= 0 && i>1) { LOG($"{biao}" + paseIndex.ToString() + "/" + (count % 2000 > 0 ? (count / 2000) + 1 : count / 2000).ToString(), ITEM, indexs, "成功,返回行数：" + num, sql); }

                            paseIndex = paseIndex + 1;

                        }
                        LOG($"{biao}", ITEM, indexs, "成功,返回行数：" + num, sql);
                    }
                    catch (Exception e)
                    {
                        LOG($"{biao}", ITEM, indexs, "失败", sql);
                        state = false;
                        PullData1(indexs, DatabaseName, tableName, biao);//跳过错误执行未执行的医院
                    }
                }
            }
            using (DbConnection configConnection = new SqlConnection(_configConnectionString))
            {
                if (state == false)
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =3  WHERE  indexs={indexs}");
                else
                    configConnection.Execute($"UPDATE [SV_QueryPlatform].[dbo].[FlowReservoirStatus] SET state =5 WHERE  indexs={indexs}");//拉取完成
            }
        }

        //Inquire
        /// <summary>
        /// 查询平台
        /// </summary>
        public void Inquire(int aa, string icd, string diseaseName, string drugName, string materialName)
        {

        }
    }
}